#version 430 core

uniform mat4 mVP;
uniform vec3 frust[8];

uniform vec3 nc;
uniform vec3 fc;

uniform vec3 normal[6];
uniform float distance[6];
uniform vec3 point[6];

layout(points) in;
layout (triangle_strip) out;
//layout(triangle_strip) out;
layout (max_vertices = 80) out;

void main () {


	gl_Position = mVP*vec4(frust[0], 1.0);
	EmitVertex();
	gl_Position = mVP*vec4(frust[1], 1.0);
	EmitVertex();
	gl_Position = mVP*vec4(frust[2], 1.0);
	EmitVertex();
	EndPrimitive();

	gl_Position = mVP*vec4(frust[2], 1.0);
	EmitVertex();
	gl_Position = mVP*vec4(frust[1], 1.0);
	EmitVertex();
	gl_Position = mVP*vec4(frust[3], 1.0);
	EmitVertex();
	EndPrimitive();
	
	gl_Position = mVP*vec4(frust[4], 1.0);
	EmitVertex();
	gl_Position = mVP*vec4(frust[5], 1.0);
	EmitVertex();
	gl_Position = mVP*vec4(frust[6], 1.0);
	EmitVertex();
	EndPrimitive();

	gl_Position = mVP*vec4(frust[6], 1.0);
	EmitVertex();
	gl_Position = mVP*vec4(frust[5], 1.0);
	EmitVertex();
	gl_Position = mVP*vec4(frust[7], 1.0);
	EmitVertex();
	EndPrimitive();
	
	gl_Position = mVP*vec4(frust[0], 1.0);
	EmitVertex();
	gl_Position = mVP*vec4(frust[4], 1.0);
	EmitVertex();
	gl_Position = mVP*vec4(frust[2], 1.0);
	EmitVertex();
	EndPrimitive();

	gl_Position = mVP*vec4(frust[2], 1.0);
	EmitVertex();
	gl_Position = mVP*vec4(frust[4], 1.0);
	EmitVertex();
	gl_Position = mVP*vec4(frust[6], 1.0);
	EmitVertex();
	EndPrimitive();
	
	
	gl_Position = mVP*vec4(frust[1], 1.0);
	EmitVertex();
	gl_Position = mVP*vec4(frust[5], 1.0);
	EmitVertex();
	gl_Position = mVP*vec4(frust[3], 1.0);
	EmitVertex();
	EndPrimitive();

	gl_Position = mVP*vec4(frust[3], 1.0);
	EmitVertex();
	gl_Position = mVP*vec4(frust[5], 1.0);
	EmitVertex();
	gl_Position = mVP*vec4(frust[7], 1.0);
	EmitVertex();
	EndPrimitive();
	
	/*
	
	for(int i=0;i<6;i++) {
	
	gl_Position = mVP*vec4(normal[i]*(distance[i]), 1.0);
	EmitVertex();
	gl_Position = mVP*vec4(normal[i]*distance[i]+vec3(0.01,0.01,0.01), 1.0);
	EmitVertex();
	gl_Position = mVP*vec4(0,0,0, 1.0);
	EmitVertex();
	EndPrimitive();
	
	}
	
	*/
}
