#version 430 core
// http://www.mbsoftworks.sk/tutorials/opengl3/23-particle-system/

uniform sampler2D sampler;

smooth in vec2 textCoords;
flat in vec4 colorPart;

out vec4 fragColor;

void main() {

	vec4 texColor = texture2D(sampler, textCoords);
	fragColor = vec4(texColor.xyz, 1.0)*colorPart;
	//fragColor = vec4(0,0,1,1);
	
}